<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>DiceRoller V12 E</title>
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    <style> 
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 0;
            background-color: #f5f5dc;
        }

        header {
            background-color: #333;
            color: white;
            padding: 1%;
            text-align: center;
        }

        img {
            width: 100%;
        }

        main {
            padding: 20px;
        }

        label {
            text-align: right;
        }
        /*styles the 5 by 6 grid and its buttons*/
        .grid-container {
            display: flex;
            justify-content: center;
            margin-top: 20px;
            margin-left: 50%;
        }

        .grid {
            display: grid;
            grid-template-columns: repeat(6, 70px);
            grid-template-rows: repeat(5, 50px);
            gap: 5px;
        }
        
        .grid button {
            background-color: lightgray;
            border: 1px solid black;
            width: 100%;
            height: 100%;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 16px;
            cursor: pointer;
        }

        .grid button:focus {
            outline: none;
        }
    </style>
</head>

<body>
        
    <header>
        <img src="Images/Bic_DiceRoller_Header.PNG" alt="DICEROLLER!">
    </header>

    <main class="container">
        <h2 class="text-center">V12 E. Input dice data.</h2>
        <p class="text-center">Most boxes will auto-fill to 0 if left unanswered</p>
            <!--text boxs-->
        <div class="row">
            <div class="col-md-6">
                <form id="myForm">
                    <div class="form-group row">
                        <label for="textbox1" class="col-sm-6 col-form-label">Advantage/Disadvantage. 1, 0, -1:</label>
                        <div class="col-sm-6">
                            <input type="text" id="textbox1" name="textbox1" class="form-control">
                        </div>
                    </div>

                    <div class="form-group row">
                        <label for="textbox2" class="col-sm-6 col-form-label">Hit dice modifier Eg. +3 or -1:</label>
                        <div class="col-sm-6">
                            <input type="text" id="textbox2" name="textbox2" class="form-control">
                        </div>
                    </div>

                    <div class="form-group row">
                        <label for="textbox3" class="col-sm-6 col-form-label">Damage dice type. 4, 6, 8, 10, 12:</label>
                        <div class="col-sm-6">
                            <input type="text" id="textbox3" name="textbox3" class="form-control">
                        </div>
                    </div>

                    <div class="form-group row">
                        <label for="textbox4" class="col-sm-6 col-form-label">How many damage dice:</label>
                        <div class="col-sm-6">
                            <input type="text" id="textbox4" name="textbox4" class="form-control">
                        </div>
                    </div>

                    <div class="form-group row">
                        <label for="textbox5" class="col-sm-6 col-form-label">Damage modifier:</label>
                        <div class="col-sm-6">
                            <input type="text" id="textbox5" name="textbox5" class="form-control">
                        </div>
                    </div>
                </form>
            </div>

            <div class="col-md-6 text-center">
                <input type="button" class="btn btn-primary" value="Roll" onclick="retrieveData(); CalculateAndPrint()">
                <input type="button" class="btn btn-secondary" value="Clear" onclick="clearForm()">
                <input type="button" class="btn btn-success" value="Save" onclick="saveData()">

                <div id="hitDiceOutput" class="mt-4"></div>
                <div id="damageOutput" class="mt-4"></div>

                <div class="grid-container">
                    <div class="grid">
                    

            <div class="grid-container">
            <div class="grid">
                <?php
                // Database connection 
                $conn = new mysqli("localhost", "ba18007", "mHM3BzksJ3J9CR", "ba18007_DiceRoller");

                if ($conn->connect_error) {
                    die("Connection failed: " . $conn->connect_error);
                }

                // SQL query to get top 30 rows and corresponding data
                $sql = "SELECT Advantage_Disadvantage, Hit_dice_modifier, Damage_dice_type, How_many_damage_dice, Damage_modifier FROM Dicedata ORDER BY ID DESC LIMIT 30";
                $result = $conn->query($sql);

                if ($result->num_rows > 0) {
                    while ($row = $result->fetch_assoc()) {
                        $buttonText = $row['Advantage_Disadvantage'] . ',' . $row['Hit_dice_modifier'] . ',' . $row['Damage_dice_type'] . ',' . $row['How_many_damage_dice'] . ',' . $row['Damage_modifier'];
                        echo '<button type="button" onclick="buttonClick(' . htmlspecialchars(json_encode($buttonText)) . ')">' . $buttonText . '</button>';
                    }
                } else {
                    echo "No results";
                }

                $conn->close();
                ?>
    </div>
</div>
                    </div>
                </div>
            </div>
        </div>

        <script>
    function retrieveData() {// pretty sure this gets the information from the database for the button that is clicked and puts it into the text boxs.
        var textbox1 = document.getElementById('textbox1').value;
        var textbox2 = document.getElementById('textbox2').value;
        var textbox3 = document.getElementById('textbox3').value;
        var textbox4 = document.getElementById('textbox4').value;
        var textbox5 = document.getElementById('textbox5').value;

        console.log("Advantage/Disadvantage:", textbox1);
        console.log("Hit Dice Modifier:", textbox2);
        console.log("Damage Dice Type:", textbox3);
        console.log("Number of Damage Dice:", textbox4);
        console.log("Damage Modifier:", textbox5);
    }

    function buttonClick(buttonData) { //pretty sure this displays the database information on the buttons.
        var data = buttonData.split(',');
        document.getElementById('textbox1').value = data[0] || ''; // Advantage/Disadvantage
        document.getElementById('textbox2').value = data[1] || ''; // Hit Dice Modifier
        document.getElementById('textbox3').value = data[2] || ''; // Damage Dice Type
        document.getElementById('textbox4').value = data[3] || ''; // How Many Damage Dice
        document.getElementById('textbox5').value = data[4] || ''; // Damage Modifier
    }

    function CalculateAndPrint() { //uses the information from the text boxs to print out the moddified hit dice roll and moddified damadge roll
        var D20Result = 0;
        var twentyA = Math.floor(Math.random() * 20) + 1;
        var twentyB = Math.floor(Math.random() * 20) + 1;
        var HitDiceTotal = 0;

        var textbox1 = document.getElementById('textbox1').value || 0;
        var textbox2 = parseInt(document.getElementById('textbox2').value) || 0;
        var textbox3 = parseInt(document.getElementById('textbox3').value) || 4;
        var textbox4 = parseInt(document.getElementById('textbox4').value) || 1;
        var textbox5 = parseInt(document.getElementById('textbox5').value) || 0;

        if (textbox1 == 1) { 
            D20Result = Math.max(twentyA, twentyB);
        } else if (textbox1 == -1) { 
            D20Result = Math.min(twentyA, twentyB);
        } else { 
            D20Result = twentyA;
        }

        HitDiceTotal = D20Result + textbox2;

        var DamageRoll = 0;
        var DamageTotal = 0;
        for (let i = 0; i < textbox4; i++) {
            DamageRoll = Math.floor(Math.random() * textbox3) + 1;
            DamageTotal += DamageRoll;
        }

        DamageTotal += textbox5;

        document.getElementById('hitDiceOutput').innerHTML = "Hit Dice Total: " + HitDiceTotal;
        document.getElementById('damageOutput').innerHTML = "Damage Total: " + DamageTotal;
    }

    function clearForm() {//clears all the data from the text boxs
        document.getElementById('myForm').reset();
        document.getElementById('hitDiceOutput').innerHTML = "";
        document.getElementById('damageOutput').innerHTML = "";
    }
    //save data saves the text box inputs to the database
    function saveData() {
        var textbox1 = document.getElementById('textbox1').value || 0;
        var textbox2 = parseInt(document.getElementById('textbox2').value) || 0;
        var textbox3 = parseInt(document.getElementById('textbox3').value) || 4;
        var textbox4 = parseInt(document.getElementById('textbox4').value) || 1;
        var textbox5 = parseInt(document.getElementById('textbox5').value) || 0;

        var xhr = new XMLHttpRequest();
        xhr.open("POST", "save_dice_data.php", true);
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

        var params = "advantage=" + textbox1 + "&hitDiceModifier=" + textbox2 + "&damageDiceType=" + textbox3 + "&numDamageDice=" + textbox4 + "&damageModifier=" + textbox5;
        console.log("Sending: " + params);

        xhr.send(params);

        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                console.log("Data saved successfully.");
            }
        };
        location.reload();  // Refresh the page after successful save
    }
</script>
    </main>

</body>

</html>